﻿/*************************************\
 *          Fehlerbehandlung         *
 *                                   *
 * Kapitel: Fortgeschrittene         *
 *           Grundlagen              *
 * Zuordnung: C#-Buch V2.0 4.2       *
 *                                   *
 *  Copyright 2015 by Benjamin Jung  *
\*************************************/
using System;

namespace CSV20.Fehlerbehandlung
{
    class Program
    {
        static void Main(string[] args)
        {
            int iZahl;

            try
            {
                Console.Write("Bitte geben Sie eine Zahl ein: ");
                // diese Funktion kann eine FormatException oder eine OverflowException auslösen
                iZahl = Convert.ToInt32(Console.ReadLine());
            }
            catch (FormatException fex)
            {
                Console.WriteLine("Ein Formatierungs-Fehler ist aufgetreten:");
                Console.WriteLine(fex.ToString());
            }
            catch (OverflowException oex)
            {
                Console.WriteLine("Ein Überlauf-Fehler ist aufgetreten:");
                Console.WriteLine(oex.ToString());
            }
            finally
            {
                Console.WriteLine("Falls wir Stream-Zugriffe o. Ä. im try-Block vornehmen können wir");
                Console.WriteLine("hier unabhängig ob der Vorgang erfolgreich war oder nicht,");
                Console.WriteLine("Ressourcen wieder freigeben (z. B. Streams schließen)");
            }

            Console.WriteLine();

            try
            {
                Console.WriteLine("Wir lösen gleich einen Fehler aus!");
                // das Auslösen von Exception's wird hauptsächlich in größeren Projekten verwendet,
                // kann jedoch in einigen Fällen sehr hilfreich sein
                throw new Exception("Ein Fehler wurde mit Absicht ausgelöst!");
            }
            // Exception ist eine Basisklasse und kann daher für eine alle Fehlerbehandlungen verwendet werden
            catch (Exception ex)
            {
                Console.WriteLine("Ein Fehler ist aufgetreten!");
                Console.WriteLine("Die übergebene Fehler-Meldung ist: " + ex.Message);
            }

            Console.ReadKey();
        }
    }
}